.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\wsock32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\wsock32.lib

WM_SHELLNOTIFY equ WM_USER+5
IDI_TRAY       equ 0
IDM_RESTORE    equ 1000
IDM_EXIT	   equ 1010
WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName 	      db "MyIPTrayWinClass",0
AppName  		db "MyIPTray",0
RestoreString	db "&MessageBox",0             ; "&Restore",0        
ExitString	 	db "E&xit Program",0
szTipMsg          db "Click for IP address(es)",0
HostNameDbg0      db "ComputerABC",0
HostAddrDbg0      db "192.168.0.1",13,10         ; IPAddress
                  db "192.168.0.3",13,10
                  db "192.168.0.5",13,10
                  db "192.168.0.7",0
                  db "                                            ",0

.data?
hInstance	dd ?
junk0       db 4 dup (?)
note        NOTIFYICONDATA <>
junk1       db 4 dup (?)
hPopupMenu	dd ?
WSAData     WSADATA <>
szBuffer    db 256 dup (?)
HostName    db 256 dup (?)
HostAddr    db 256 dup (?)
HostAddrDbg db 256 dup (?)
edy         dd ?
esy         dd ?
ecy         dd ?


.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
 ;       mov    dword ptr szBuffer, 4E4F4E45h
 ;       mov    dword ptr note.szTip, 454E4F4Eh
 ;       mov    dword ptr junk0, 4E4F4E45h
 ;       mov    dword ptr junk1, 45454545h
      mov dword ptr HostAddr, 454E4F4Eh
	invoke WinMain, hInstance,NULL,NULL, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_APPWORKSPACE
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
                                                           ;ADDR AppName   
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR HostAddr,\
           WS_OVERLAPPED+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX+WS_MAXIMIZEBOX+WS_VISIBLE+WS_MINIMIZE,\
           CW_USEDEFAULT,CW_USEDEFAULT,350,200,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	.while TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL pt:POINT
	.if uMsg==WM_CREATE
		invoke CreatePopupMenu
		mov hPopupMenu,eax
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_RESTORE,addr RestoreString
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_EXIT,addr ExitString
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.elseif uMsg==WM_SIZE
		.if wParam==SIZE_MINIMIZED
			mov note.cbSize,sizeof NOTIFYICONDATA
			push hWnd
			pop note.hwnd
			mov note.uID,IDI_TRAY
			mov note.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP
			mov note.uCallbackMessage,WM_SHELLNOTIFY
			invoke LoadIcon,NULL,IDI_WINLOGO
			mov note.hIcon,eax
                  ; mov dword ptr note.szTip, 454E4F4Eh
			invoke lstrcpy,addr note.szTip,addr szTipMsg  ; AppName IPAddress HostAddrDbg HostAdrr szTipMsg
			invoke ShowWindow,hWnd,SW_HIDE
			invoke Shell_NotifyIcon,NIM_ADD,addr note
		.endif
	.elseif uMsg==WM_COMMAND
		.if lParam==0
			; invoke Shell_NotifyIcon,NIM_DELETE,addr note
			mov eax,wParam
			.if ax==IDM_RESTORE

                        invoke WSAStartup, 101h,ADDR WSAData
                        or eax,eax
                        jnz @sockerr
                    
                        invoke gethostname, ADDR HostName,SIZEOF HostName
                        or eax,eax
                        jnz @nameerr
                    
                        invoke gethostbyname, ADDR HostName
                        or eax,eax
                        jz @noname

                        push edi
                        push esi
                        mov edi,OFFSET HostAddr
                        mov eax,[eax+12] ;;hostent.h_list
                        mov edx,eax
                      @1:
                        mov eax,[edx]
                        or eax,eax
                        jz @show
                        mov eax,[eax]
                        push edx
                        invoke inet_ntoa, eax
                        mov esi,eax
                      @@:
                        mov al,[esi]
                        mov [edi],al
                        inc edi
                        inc esi
                        or al,al
                        jnz @B
                        dec edi
                        mov BYTE PTR[edi],13
                        inc edi
                        pop edx
                        add edx,4
                        jmp @1
                    
                      @show:
                        dec edi
                        mov [edi],al ;since jmp was because eax==0
                        pop esi
                        pop edi

                        invoke WSACleanup

                   @sockerr:
                   @nameerr:
                   @noname:
                   Past:
 ;                         mov ecy, ecx
 ;                         mov esy, esi
 ;                         mov edy, edi
 ;                         mov ecx, 64                     ; 256
 ;                         mov esi, OFFSET HostAddr
 ;                         mov edi, OFFSET HostAddr
 ;                         ; mov edi, OFFSET note.szTip      ; HostAddrDbg
 ;                       @@:
 ;                         sub ecx, 4
 ;                         mov eax, [esi+ecx]
 ;                         mov [edi+ecx], eax
 ;                         or  ecx,ecx
 ;                         jnz @B
 ;                         mov edi, edy
 ;                         mov esi, esy
 ;                         mov ecx, ecy
                         
                        invoke MessageBox,NULL,ADDR HostAddr,ADDR HostName,\
                               MB_SETFOREGROUND+MB_SERVICE_NOTIFICATION+MB_TOPMOST+MB_OK
                               ; MB_ICONHAND OR MB_SYSTEMMODAL OR MB_SERVICE_NOTIFICATION OR MB_SETFOREGROUND
                        ; invoke MessageBox,hWnd,ADDR HostAddr,ADDR HostName,MB_OK    ; HostAddr HostName
                        ; invoke MessageBox,hWnd,ADDR HostAddrDbg,ADDR HostNameDbg,MB_OK    ; HostAddr HostName
 			      ; invoke ShowWindow,hWnd,SW_RESTORE
				; invoke ShowWindow,hWnd,SW_HIDE          ; SW_RESTORE
			.else
			    invoke Shell_NotifyIcon,NIM_DELETE,addr note				
                      invoke DestroyWindow,hWnd
			.endif
		.endif
	.elseif uMsg==WM_SHELLNOTIFY
		.if wParam==IDI_TRAY
			.if lParam==WM_RBUTTONDOWN
				invoke GetCursorPos,addr pt
				invoke TrackPopupMenu,hPopupMenu,TPM_RIGHTALIGN,pt.x,pt.y,NULL,hWnd,NULL
			.elseif lParam==WM_LBUTTONUP
				invoke SendMessage,hWnd,WM_COMMAND,IDM_RESTORE,0
			.elseif lParam==WM_LBUTTONDBLCLK
				invoke SendMessage,hWnd,WM_COMMAND,IDM_RESTORE,0
			.endif
		.endif
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

end start
